var lastkey          = "";
var context          = "";
var botonitos        = [];
var chanvars         = [];

var pingcount        = 0;
var notID            = 0;
var ws;

var wshost = localStorage["wshost"];
var wsport = localStorage["wsport"];
var exten  = localStorage["exten"];
var context= localStorage["context"];
var secret = localStorage["pass"];
var popup  = localStorage["popup"];
var langu  = localStorage["language"];
var prefix = localStorage["prefix"];

if(langu === undefined) {
    langu='en';
}

if (wsport === undefined) {
    wsport=4445;
}

var animator = new BadgeTextAnimator ( {
    text: 'Unable to connect to server', // text to be scrolled (or animated)
    interval: 200, // the "speed" of the scrolling
    repeat: true, // repeat the animation or not
    size: 6 // size of the badge
});

chrome.contextMenus.create({title: lang[langu].dial+" '%s'",
    contexts:["selection"],
    onclick: function(info, tab){ dial(info.selectionText); }
});

chrome.extension.onRequest.addListener(
    function(request, sender, sendResponse) {
        /** On load parse request **/
        if ( request['pageLoaded'] ) {
            sendResponse ({ 'parsePage' : true });
        } else
        if ( request['makeCall'] ) {
            dial(request['phoneNumber']);
        } else
        if ( request['getLocalStorage'] ) {
            sendResponse({ 'data' : localStorage[request['key']]});
        } else {
            debug(request);;
        }
    }
);

// Envio comando dial al fop2 server
function dial(numerodestino) {
    numerodestino = stripNonNumeric(numerodestino);
    prefix = stripNonNumeric(prefix);

    if(numerodestino.length>0) {
        if(myposition>0) {
            var clave = secret+lastkey;
            var hash = hex_md5(clave);
            var useorigin = myposition;
            var comando = "<msg data=\""+useorigin+"|dial|"+prefix+numerodestino+"|"+hash+"\" />";
            send(comando);
        } else {
            debug("unable to dial, no position defined");
        } 
    } else {
        debug("no dial as number is zero length");
    }
}

function connectWebsocket(name) {

    debug('connect xml to '+wshost+' at port '+wsport);

    if ("WebSocket" in window) {

        var wshoststring = "ws://" + wshost + ":" + wsport;

        try {
            ws = new WebSocket(wshoststring);
        } catch(err) {
            debug("web socket error");
        }

        ws.onopen = function() {
            animator.stop();
            connectContext();
        };

        ws.onmessage = function(evt) {
            var data = jQuery.parseJSON(evt.data);
            appendData(data);
        };

        ws.onclose = function() {
            //chrome.browserAction.setIcon({ 'path': "images/telephone19red.png"});
            setTimeout( function() { connectWebsocket() }, 5000 );
            animator.stop();
            animator.options.text='Unable to connect to server';
            animator.index=0;
            animator.animate();
            debug("Animacion: unable to connect");
        };

        ws.onerror = function(evt) {
            debug(evt);
        };
    } 
}


function askFirstState() {
    var clave = secret+lastkey;
    var hash = hex_md5(clave);
    var comando = "<msg data=\"1|initState||"+hash+"\" />";
    send(comando);
};

function connectContext() {
    if(context!=="") {
        var context_upper = context.toUpperCase();
        send("<msg data=\""+context_upper+"|contexto|1|\" />");
    } else {
        send("<msg data=\"GENERAL|contexto|1|\" />");
    }
    setTimeout( function() { sends_ping() }, 10000 );
};

function sends_ping() {
    debug("ping "+pingcount);
    if(pingcount>5) {
        debug("Connection problem with websocket server!");
    }
    var comando = "<msg data=\"1|ping||\" />";
    send(comando);
    pingcount++;
}

function debug(message) {
    if(window.console !== undefined) {
        console.log(message);
    }
};

function send(str) {
    debug("sending command "+str);
    ws.send(str);
}

function commandCenter() {
    
    function key(nro,texto,slot) {
       chrome.browserAction.setIcon({ path: "images/telephone19.png"});
       animator.options.text='ok';
       animator.stop();
       lastkey = texto;
    }

    function version(nro,texto,slot) {
        var clave = secret+lastkey;
        var hash = hex_md5(clave);
        var comando = "<msg data=\"1|auth|"+exten+"|"+hash+"\" />";
        send(comando);
    }

    function incorrect(nro,texto,slot) {
        debug("Auth incorrect");
        //chrome.browserAction.setIcon({ path: "images/telephone19red.png"});
        if(animator.intervalId === null) {
            animator.options.text = 'Invalid Credentials';
            animator.index=0;
            animator.animate();
        } 
    }

    function clidnum(nro,texto,slot) {
        if(myposition==nro) {
            if(chanvars[nro] === undefined ) {
                chanvars[nro] = {};
            }
            chanvars[nro]['CLIDNUM'] = texto;
        }
    }

    function clidname(nro,texto,slot) {
        if(myposition==nro) {
            if(chanvars[nro] === undefined ) {
                chanvars[nro] = {};
            }
            chanvars[nro]['CLIDNAME'] = texto;
        }
    }

    function fromqueue(nro,texto,slot) {
        if(myposition==nro) {
            if(chanvars[nro] === undefined ) {
                chanvars[nro] = {};
            }
            chanvars[nro]['FROMQUEUE'] = texto;
        }
    }

    function setvar(nro,texto,slot) {
        if(myposition==nro) {
            var textdecode = Base64.decode(texto);
            if(textdecode.indexOf("=")>=1) {
                if(chanvars[nro] === undefined ) {
                    chanvars[nro] = {};
                }
                partes = textdecode.split("=");
                chanvars[nro][partes[0]]=partes[1];
           }
       }
    } 

    function notifyconnect(nro,texto,slot) {
        actualnotify(nro,'connected_call');
    }

    function notifyringing(nro,texto,slot) {
        actualnotify(nro,'incoming_call');
    }

    function actualnotify(nro,titulo) {

        if(myposition==nro) {

            // Set option variables to define behaviour

            var poplink  = localStorage["poplink"];
            if(poplink === undefined) { poplink=''; }

            if(poplink != '') {
                // only open popup link if defined
                var patt1=/#\{[^\}]*\}/g;
                var coinciden = poplink.match(patt1);
                for(var a=0; a<coinciden.length; a++) {
                    var vari = coinciden[a].substr(2,coinciden[a].length-3);
                    var valor='';
                    if (vari=='CLIDNUM' || vari=='CLIDNAME') {
                        valor = Base64.decode(chanvars[nro][vari]);
                    } else {
                        valor = chanvars[nro][vari];
                    }
                    poplink = replace(poplink, coinciden[a], valor);
                }
                //debug(poplink);
                chrome.tabs.create({url: poplink, active: false});
            } 

            if(popup==1) {
                var duration  = parseInt(localStorage["duration"]) * 1000;
                if(duration === undefined) { duration=0; }

                // call notifications enabled
                queryString = "&TITLE="+encodeURIComponent(translate('&'+titulo));
                var tituloText = translate('&'+titulo);
                var notiText = "";
                if(chanvars[nro] !== undefined ) {
                   for (var j in chanvars[nro]) {
                       queryString=queryString+"&"+j+"="+chanvars[nro][j];
                       notiText+=Base64.decode(chanvars[nro][j])+"\n";
                   }
                }
                //debug(queryString);
                var noticeURL = chrome.extension.getURL('notification.html') + "?" + queryString;
                var image     = chrome.extension.getURL('images/telephone48.png');

                //  deprecaron el html notification en chrome .28 !!
                //  var notification = webkitNotifications.createHTMLNotification( noticeURL );

                //  deprecaron webkitNotifications tambien
                //  var notification = window.webkitNotifications.createNotification(
                //    image,
                //    tituloText,
                //    notiText
                //  );
                //  notification.show();
                //
                //  if(duration>0) {
                //    var myRing = setTimeout( function() { notification.cancel() }, duration );
                //  }

                chrome.notifications.create(
                    'notification'+notID++,{   
                    type: 'basic', 
                    iconUrl: image, 
                    title: tituloText, 
                    message: notiText 
                    }, creationCallback 
                );

                //if(duration>0) {
                //    var myRing = setTimeout( function() { chrome.notifications.clear('notification', function(wasCleared) { console.log("Notification cleared: " + wasCleared); }); }, duration );
                //}
            }
        }
    }

    function creationCallback(notID) {
        var duration  = parseInt(localStorage["duration"]) * 1000;
        if(duration === undefined) { duration=0; }

        console.log("Succesfully created " + notID + " notification");
        //if(duration==0) { duration=10000; }
        if (duration>0) {
            setTimeout(function() {
                chrome.notifications.clear(notID, function(wasCleared) {
                    console.log("Notification " + notID + " cleared: " + wasCleared);
                });
            }, duration);
        }
    }

    function pong(nro,texto,slot) {
        setTimeout( function() { sends_ping() }, 20000 );
        pingcount--;
    }

    function zbuttons(nro,texto,slot) {

        botonitos        = [];
        chanvars         = [];

        var lineas =     '';
        try {
            window.atob(str);
            lineas = Base64.decode(texto).split("\n");
        } catch(e) {
           // not base 64
           var inflator = new Inflator(new Base64Reader(texto));
           var textReader = new TextReader(new Utf8Translator(inflator));
           lineas = textReader.readToEnd().split("\n");
        }

        for (var x = 0; x<lineas.length; x++) {
            var pepe = lineas[x].split("!");
            var nritoPartes = pepe[0].split("@");
            var nrito = nritoPartes[0];
            for (var s = 0; s<pepe.length; s++) {
                var partos = pepe[s].split("=",2);

                if(botonitos[nrito] == undefined) {
                    botonitos[nrito]={};
                }
                botonitos[nrito][partos[0]]=partos[1];

                if(partos[0]!=="") {
                    if(partos[0]=="EXTENSION") {
                        if(partos[1]==exten) {
                           myposition=nrito;
                           debug('My position is '+myposition);
                        }
                    }
                }
            }
        }

        for (var s = 0; s<botonitos.length; s++) {
            if(botonitos[s]!==undefined) {
                if(botonitos[s]['TYPE']=='extension') {
                    var myLabel = botonitos[s]['EXTENSION']+' '+botonitos[myposition]['LABEL'];
                    var popupWindow = chrome.extension.getViews({'type': 'popup'}); 
                    if (popupWindow.length) {         
                        popupWindow = popupWindow[0];
                        var streamOutput = popupWindow.document.getElementById('label_'+s);
                        streamOutput.innerHTML = myLabel;
                    } 
                }
            }
        }

        askFirstState();
    }

    function voicemail(nro,texto,slot) {

        botonitos[nro]['MWISTATE']=texto;

        var popupWindow = chrome.extension.getViews({'type': 'popup'}); 
        if (popupWindow.length) {         
            popupWindow = popupWindow[0];
            var elm = popupWindow.document.getElementById('mwi_'+nro);
            if(texto==1) {
                $(elm).removeClass('transparent');
                $(elm).removeClass('invisible');
            } else if(texto==2) {
                $(elm).removeClass('invisible');
                $(elm).addClass('transparent');
            } else {
                $(elm).addClass('invisible');
                $(elm).removeClass('transparent');
            }
        } 
    }

    function qualify(nro,texto,slot) {

        botonitos[nro]['QUALIFY']=texto;

        var popupWindow = chrome.extension.getViews({'type': 'popup'});

        if (popupWindow.length) {         
            popupWindow = popupWindow[0];
            var btn = popupWindow.document.getElementById('boton_'+nro);
            if(btn !== null) {
                if(texto=='ok') {
                    $(btn).removeClass('transparent');
                } else {
                    $(btn).addClass('transparent');
                }
            }
        }
    }

    function xpresence(nro,texto,slot) {

    }

    function state(nro,texto,slot) {

        var estadofinal = '';
        var estadosacar = '';
        var estados = texto.split("+");
        if(jQuery.inArray('RINGING',estados)>=0 || jQuery.inArray('UP',estados)>=0) {
            botonitos[nro]['STATE']="busy"
            estadosacar='free';
            estadofinal='busy';
        } else {
            botonitos[nro]['STATE']="free"
            estadosacar='busy';
            estadofinal='free';

            // Borro variables de canal en state down
            if(myposition==nro) {
                if(chanvars[nro] !== undefined ) {
                    for (var j in chanvars[nro]) {
                        delete chanvars[nro][j];
                    }
                }
            }

        }

        var popupWindow = chrome.extension.getViews({'type': 'popup'});

        if (popupWindow.length) {         
            popupWindow = popupWindow[0];
            var btn = popupWindow.document.getElementById('boton_'+nro);
            if(btn !== null) {
                $(btn).removeClass(estadosacar);
                $(btn).addClass(estadofinal);
            }
        }
    }

    this.zbuttons    = zbuttons;
    this.voicemail   = voicemail;
    this.pong        = pong;
    this.state       = state;
    this.presence    = xpresence;
    this.key         = key;
    this.setvar      = setvar;
    this.incorrect   = incorrect;
    this.version     = version;
    this.qualify     = qualify;
    this.clidnum     = clidnum;
    this.clidname    = clidname;
    this.fromqueue    = fromqueue;
    this.notifyringing    = notifyringing;
    this.notifyconnect    = notifyconnect;

}

function docommand(nro,comando,texto,slot) {

    if(comando == "status") {
        // status is a reserved word
        comando = "xstatus";
    }

    if(comando!="zbuttons") {
       debug(nro+","+comando+"="+texto+" en slot "+slot);
    }

    if (typeof execute[comando] == "function") {
       execute[comando](nro,texto,slot);
    } else {
       //debug("Comando "+comando+" no implementado");
    }

}

function onCloseEvent() {
    debug("close event "+conectado);
}

function appendData(data) {
    var textobtn  = data['btn'];
    if(textobtn.indexOf("@")>=1) {
        textobtn = textobtn.substring(0,textobtn.indexOf("@"));
    }
    docommand(textobtn,data['cmd'],data['data'],data['slot']);
}

function stripNonNumeric( str ) {
    // This function removes non-numeric characters
    str += '';
    var rgx = /^\d$/;
    var out = '';
    for( var i = 0; i < str.length; i++ ) {
        if( rgx.test( str.charAt(i) ) ){
            if( !( ( str.charAt(i) == '.' && out.indexOf( '.' ) != -1 ) ||
                 ( str.charAt(i) == '-' && out.length != 0 ) ) ){
                     out += str.charAt(i);
            }
        }
    }
    return out;
}

function replace(string,text,by) {
    // Replaces text with by in string
    var strLength = string.length, txtLength = text.length;
    if ((strLength === 0) || (txtLength === 0)) { return string; }

    var i = string.indexOf(text);
    if ((!i) && (text != string.substring(0,txtLength))) { return string; }
    if (i == -1) { return string; }

    var newstr = string.substring(0,i) + by;

    if (i+txtLength < strLength) {
        newstr += replace(string.substring(i+txtLength,strLength),text,by);
    }

    return newstr;
};

var execute = new commandCenter();
//chrome.browserAction.setIcon({ path: "images/telephone19red.png"});


if(wshost === undefined) {
    animator.stop();
    animator.options.text='Unconfigured Host';
    animator.index=0;
    animator.animate();
} else {
    connectWebsocket();
}
