document.addEventListener('DOMContentLoaded', function () {
    document.getElementById('optionsLabel').innerHTML=lang[langu]['options'];
    document.getElementById('closeLabel').innerHTML=lang[langu]['close'];
    document.getElementById('popupClose').addEventListener('click', function() { window.close(); });
    document.getElementById('optionsOpen').addEventListener('click', openOptions);
    document.getElementById('filtertext').addEventListener('click', function() { filter_list(); });
    document.addEventListener('keyup', function(event){ key_up(event);});
    setButtons();
});


function key_up(event) {
    if(event.keyCode==27) {
        filter_list();
    } else {
        if(event.target.id == 'filtertext') {
            filter_list();
        }
    }
}

function filter_list() {
    var mostrar = [];
    var text_filter = $('#filtertext').val();
    text_filter = text_filter.toLowerCase();
    $('#listabotones').find('.label').each( function(i) { 
        var btnnro = this.id.substring(5,this.id.length);
        if(!$('#boton'+btnnro).hasClass('nodisplay')) {
            $('#boton'+btnnro).show();
    		if(text_filter != "") {
               contiene = $('#boton'+btnnro).text().toLowerCase();
               var result = contiene.indexOf(text_filter);
               if(result == -1) {
                   if(mostrar[btnnro] === undefined) {
                       $('#boton'+btnnro).hide();
                   }
               } 
            }
        } 
    });
}

function openOptions() {
    chrome.tabs.create({ 'url': "options.html" });
}

function setButtons() {

    var botones = chrome.extension.getBackgroundPage()['botonitos'];
    var position = chrome.extension.getBackgroundPage()['myposition'];

    if(botones[position]!==undefined) {
        if(botones[position]['EXTENSION']!==undefined) {
            drawButton(position,botones[position],'strong');
        }
    }

    for (var s = 0; s<botones.length; s++) {
         if(botones[s]!==undefined) {
             if(botones[s]['TYPE']=='extension') {
                 if(botones[s]['EXTENSION']!==undefined) {
                     if(s != position) {
                         drawButton(s,botones[s],'');
                     }
                }
            }
        }
    }
}

function drawButton(id,botState,bold) {

     var botonstate='free';
     var qualy="";
     var label = botState['EXTENSION']+' '+botState['LABEL'];

     if(botState['STATE']=='busy') {
         botonstate='busy';
     }
     if(botState['MWISTATE']=='2') {
         mwistate = 'transparent';
     } else
     if(botState['MWISTATE']=='1') {
         mwistate = 'visible';
     } else {
         mwistate = 'invisible';
     }
     if(botState['QUALIFY']) {
         if(botState['QUALIFY']=='notok') {
             qualy='nodisplay';
         } 
     }

     var elm = jQuery('<div/>', { 'id': 'boton_'+id, 'class': 'boton '+botonstate+' '+qualy }).appendTo('#listabotones');
     var lin = jQuery('<div/>', { 'class': 'linewrapper'}).appendTo(elm);
     jQuery('<div/>', { 'id': 'label_'+id, 'class': 'label '+bold, 'text': label}).appendTo(lin);
     jQuery('<div/>', { 'id': 'mwi_'+id,   'class': 'mwi '+mwistate}).appendTo(lin);

}
